/*
    GeekeBrain Tero 
    1.10 Se añade bloque de GkShade

    1.9 Ajuste GkEngine Motor

    1.8 Comprobar versión Firmware.

    1.7.1 Revisión bloque interruptor digital y ordenado de código.

    1.7 Revisión bloque interruptor digital.

    1.6 Se añade lectura pines digitales mapeados al puerto.
    
    1.5 Código Arduino Ultrasonidos.

    1.4 Lectura de anlógico, digital y ultrasonidos.

    1.3 Se cambia nombres de GkEngine a M y S

    1.2 Se añade GkBuzzer

    1.0
*/


function delay(milliseconds) {
    trace('Waiting for ' + milliseconds + ' miliseconds');
    window.setTimeout(function() {
        callback();
    }, milliseconds);

    /*
    var start = new Date().getTime();
    for (var i = 0; i < 1e7; i++) {
        if ((new Date().getTime() - start) > milliseconds){
            break;
        }
    }
    */
}



(function(ext) {
    var device = null;
    var _rxBuf = [];

    // Tiempo que le lleva a un servo hacer un grado, ya se que hay servos mas rapido y mas lentos, mas o menos!!    
    var SERVO_TIME_PER_DEGRADE = 160;

    // Sensor states:
    var ports = {
        Port1: 1,
        Port2: 2,
        Port3: 3,
        Port4: 4,
        Port5: 5,
        Port6: 6,
        Port7: 7,
        Port8: 8,
        M1:6,
        M2:10
    };
    var slots = {
        Slot1:1,
        Slot2:2
    };
    var switchStatus = {
        On:1,
        Off:0
    };
    var levels = {
        HIGH:1,
        LOW:0
    };

    var axisGlobal = {
        'Axis X': 0,
        'Axis Y': 1,
        'Axis Z': 2
    }

    var tones ={
        "B0":31,"C1":33,"D1":37,"E1":41,"F1":44,"G1":49,"A1":55,"B1":62,
        "C2":65,"D2":73,"E2":82,"F2":87,"G2":98,"A2":110,"B2":123,
        "C3":131,"D3":147,"E3":165,"F3":175,"G3":196,"A3":220,"B3":247,
        "C4":262,"D4":294,"E4":330,"F4":349,"G4":392,"A4":440,"B4":494,
        "C5":523,"D5":587,"E5":659,"F5":698,"G5":784,"A5":880,"B5":988,
        "C6":1047,"D6":1175,"E6":1319,"F6":1397,"G6":1568,"A6":1760,"B6":1976,
        "C7":2093,"D7":2349,"E7":2637,"F7":2794,"G7":3136,"A7":3520,"B7":3951,
        "C8":4186,"D8":4699
    };

    var beats = {"Half":500,"Quarter":250,"Eighth":125,"Whole":1000,"Double":2000,"Zero":0};
    var values = {};  
    var indexs = [];
     
    var startTimer = 0;
    var versionIndex = 0xFA;

    var angleServos = [];

    //var motorSpeedGlobal = 50;


    /**************************************************/



    ext.runGkEngineMotor = function(motorDir, motorWhat, motorValue) {
        //alert("dir " + motorDir + "   what " + motorWhat ); 
        if (motorDir == "FORWARD"){
            motorDir = 1;

        }else if(motorDir == "TO RIGHT"){
            motorDir = 2;

        }else if(motorDir == "TO LEFT"){
            motorDir = 3;

        }else if(motorDir == "BACKWARDS"){
            motorDir = 4;

        }else if(motorDir == "STOP"){
            motorDir = 0;

        }else{
            alert("Solo es valido 'A la Derecha', 'A la Izquierda', 'Avanza', 'Retrocede' y 'Parar'. " + motorDir);

        }

        if (motorValue > 100){
            motorValue = 100;
        }else if (motorValue < 0){
            motorValue = 0;
        }    

        if (motorWhat == "STEPS"){
            //alert("1 dir " + motorDir + "   what " + motorWhat + "   value " + motorValue);
            runPackage(10, 0, short2array(motorDir), short2array(0), short2array(motorValue));

        // "VELOCITY"
        }else{
            //motorSpeedGlobal = motorValue;

            //alert("2 dir " + motorDir + "   what " + motorWhat + "   value " + motorValue);
            runPackage(10, 0, short2array(motorDir), short2array(motorValue), short2array(0));
        }
    };


    ext.runGkEngineServo = function(motorDir, motorWhat, motorValue) {
        if (motorDir == "FORWARD"){
            motorDir = 1;

        }else if(motorDir == "TO RIGHT"){
            motorDir = 2;

        }else if(motorDir == "TO LEFT"){
            motorDir = 3;

        }else if(motorDir == "BACKWARDS"){
            motorDir = 4;

        }else if(motorDir == "STOP"){
            motorDir = 0;

        }else{
            alert("Solo es valido 'A la Derecha', 'A la Izquierda', 'Avanza', 'Retrocede' y 'Parar'. " + motorDir);

        }

        if (motorValue > 100){
            motorValue = 100;
        }else if (motorValue < 0){
            motorValue = 0;
        }    

        if (motorWhat == "STEPS"){
            runPackage(60, 0, short2array(motorDirGlobal), 0, short2array(motorValue));

        // "VELOCITY"
        }else{
            //motorSpeedGlobal = motorValue;

            runPackage(60, 0, short2array(motorDir), short2array(motorValue), 0);
        }

    };


    ext.runGkColor = function(red, green, blue) {
        //alert(red + " - " + green + " - " + blue);
        if (red < 0 || red > 100){
            //alert("El valor de Rojo tiene que estar entre 0 (apagado) y 100 (a tope!).")
            red = 0;
        }
        if (green < 0 || green > 100){
            //alert("El valor de Verde tiene que estar entre 0 (apagado) y 100 (a tope!).")
            green = 0;
        }
        if (blue < 0 || blue > 100){
            //alert("El valor de Azul tiene que estar entre 0 (apagado) y 100 (a tope!).")
            blue = 0;
        }
        runPackage(8, 0, short2array(red), short2array(green), short2array(blue));
    };



    ext.runDigital = function(level, pin) {
        if (level == "ON"){
            level = 1;
        }else if(level == "OFF"){
            level = 0;
        }else{
            alert("Solo se puede ponerse 'Encender' o 'Apagar', fijate bien!");
        }
        pin = new Number(pin); 

        if (pin < 1 || pin > 8){
            alert("En el GeekeBrain Tero solo pueden encenderse/apagarse los pines digitales del 1 al 8, fijate bien!");

        }
        //alert("runDigital " + pin + " level: " + level);

        runPackage(30, pin, level);
    };


    /*
        TEST:
            1) Si se pone un pin que no este entre 1 y 8, mensaje error.
            2) Si no se fijo un angulo fijo al pin con otro bloque, mensaje error.
            3) Si se pone un sentido distinto de "LEFT" o "RIGHT", mesaje error.
    */
    ext.runGkServo = function(side, angle, port) {
        // Si no había un tiempo previo marcado se da un margen.
        if(angleServos[port] == undefined){ 
            delay(180 * SERVO_TIME_PER_DEGRADE);
            angleServos[port] = 0;            
        }else{
            // Da un margen de tiempo entre la diferencia de grados que se mueve por un tiempo necesario por grado.
            difAngle = Math.abs(angleServos[port] - angle);
            delay(difAngle * SERVO_TIME_PER_DEGRADE);            
        }  


        // La primera vez que se envia a la derecha o la izquierda, parte de la posición 90º
        if (angleServos[port] == undefined){
            if (side == "TO LEFT" || side == "TO RIGHT"){
                alert("90");
                angleServos[port] = 90;
            }
        }      

        if (side == "TO LEFT"){
            angle = angleServos[port] + angle;
        }else if(side == "TO RIGHT"){
            angle = angleServos[port] - angle;
        }else if(side == "MOVE AT"){
            angle = angle;            
        }else{
            alert("El Servo solo puede ir a la 'Derecha' o a la 'Izquierda', fijate bien!");
        }

        port = new Number(port) 
        if (port < 1 || port > 8){
            alert("En el GeekeBrain Tero solo tiene puertos del 1 al 8, fijate bien!");

        }

        angle = new Number(angle); 
        if (angle < 0 ){
            angle = 0;
        } else if (angle > 180){
            angle = 180;
        }

        /*
        for (var i = angleServos.length - 1; i >= 0; i--) {
             trace("Angulo " + i + " " + angleServos[i]);
        }
        */
       
       
        //alert("GkServo " + port + "  angulo " + angle);
        runPackage(33, port, angle);

        angleServos[port] = angle; 

    };


    ext.runServoArduino = function(angle,pin){
        runPackage(33,pin,angle);
    };

    ext.runGkBuzzer = function(tone, beat){
        if (typeof tone!="number"){
            tone = tones[tone];
        }
        if (typeof beat!="number"){
            beat = beats[beat];
        }
        //alert("GkBuzzer " + pin + "  tone " + tone + "  beat " + beat);
        runPackage(34, 0, short2array(tone), short2array(beat));
    };


    ext.resetTimer = function(){
        startTimer = new Date().getTime();
        responseValue();
    };


	// Gets ------------------------------------------------------------
    ext.getGkSonic = function(nextID,trig){
        var deviceId = 36;
        getPackage(nextID,deviceId,trig);
    }


    ext.getGkGyro = function(nextID, axis) {
        var deviceId = 6;
        if (typeof axis == "string") {
            axis = axisGlobal[axis];
        }
        //alert("Axis " + axis );
        // El tres es el puerto puesto a pelo
        getPackage(nextID, deviceId, 3, axis);
    };

    ext.getGkShade = function(nextID,pin){
        var deviceId = 30;
        getPackage(nextID,deviceId,pin);
    };

    ext.getDigital = function(nextID,pin){
        var deviceId = 30;
        getPackage(nextID,deviceId,pin);
    };

    ext.getAnalog = function(nextID,pin) {
        var deviceId = 31;
        getPackage(nextID,deviceId,pin);
    };

    ext.getPulse = function(nextID,pin,timeout) {
        var deviceId = 37;
        getPackage(nextID,deviceId,pin,short2array(timeout));
    };


    ext.getTimer = function(nextID){
        if(startTimer==0){
            startTimer = new Date().getTime();
        }
        responseValue(nextID,new Date().getTime()-startTimer);
    };


    ext.getVersion = function(nextID) {
        var deviceId = 0;
        getPackage(nextID, deviceId);
    };


    // Gestión de comunicación --------------------------------------------------------------------------------------   
    function runPackage(){
        sendPackage(arguments, 2);
    }

    function getPackage(){
        var nextID = arguments[0];
        Array.prototype.shift.call(arguments);
        sendPackage(arguments, 1);
    }

    function sendPackage(argList, type){
        var bytes = [0xff, 0x55, 0, 0, type];
        for(var i=0;i<argList.length;++i){
            var val = argList[i];
            if(val.constructor == "[class Array]"){
                bytes = bytes.concat(val);
            }else{
                bytes.push(val);
            }
        }
        bytes[2] = bytes.length - 3;
        device.send(bytes);
    }
    

    var inputArray = [];
    var _isParseStart = false;
    var _isParseStartIndex = 0;
    function processData(bytes) {
        var len = bytes.length;
        if(_rxBuf.length>30){
            _rxBuf = [];
        }
        for(var index=0;index<bytes.length;index++){
            var c = bytes[index];
            _rxBuf.push(c);
            if(_rxBuf.length>=2){    
                if(_rxBuf[_rxBuf.length-1]==0x55 && _rxBuf[_rxBuf.length-2]==0xff){
                    _isParseStart = true;
                    _isParseStartIndex = _rxBuf.length-2;
                }
                if(_rxBuf[_rxBuf.length-1]==0xa && _rxBuf[_rxBuf.length-2]==0xd&&_isParseStart){
                    _isParseStart = false;
                    
                    var position = _isParseStartIndex+2;
                    var extId = _rxBuf[position];
                    position++;
                    var type = _rxBuf[position];
                    position++;
                    //1 byte 2 float 3 short 4 len+string 5 double
                    var value;
                    switch(type){
                        case 1:{
                            value = _rxBuf[position];
                            position++;
                        }break;

                        case 2:{
                            value = readFloat(_rxBuf,position);
                            position+=4;
                            if(value<-255||value>1023){
                                value = 0;
                            }
                        }break;

                        case 3:{
                            value = readInt(_rxBuf,position,2);
                            position+=2;
                        }break;

                        case 4:{
                            var l = _rxBuf[position];
                            position++;
                            value = readString(_rxBuf,position,l);
                        }break;

                        case 5:{
                            value = readDouble(_rxBuf,position);
                            position+=4;
                        }break;

                        case 6:{
                            value = readInt(_rxBuf,position,4);
                            position+=4;
                        }break;
                    }
                    //alert("Id: " + extId + "    Type: " + type + "    rxBuf: " + _rxBuf + "    Value: " + value);
                    if(type<=6){
                        responseValue(extId, value);
                    }else{
                        responseValue();
                    }
                    _rxBuf = [];
                }
            } 
        }
    }


    function readFloat(arr,position){
        var f= [arr[position],arr[position+1],arr[position+2],arr[position+3]];
        return parseFloat(f);
    }


    function readInt(arr,position,count){
        var result = 0;
        for(var i=0; i<count; ++i){
            result |= arr[position+i] << (i << 3);
        }
        return result;
    }


    function readDouble(arr,position){
        return readFloat(arr,position);
    }


    function readString(arr,position,len){
        var value = "";
        for(var ii=0;ii<len;ii++){
            value += String.fromCharCode(_rxBuf[ii+position]);
        }
        return value;
    }


    function appendBuffer( buffer1, buffer2 ) {
        return buffer1.concat( buffer2 );
    }


    // Extension API interactions -------------------------------------------------------
    // TODO: Hacer un bloque de scratch que muestre los errores acumulados con un alert.
    // O hacer un bloque que ponga en modo debug y muestre los mensajes de error.

    // Se ejecuta cuando se le da a la baderita
    ext.resetAll = function(){
        device.send([0xff, 0x55, 2, 0, 4]);
    };

    
    ext.runArduino = function(){
        //alert("runArduino");
        responseValue();
    };


    var potentialDevices = [];
    ext._deviceConnected = function(dev) {
        potentialDevices.push(dev);

        if (!device) {
            tryNextDevice();
        }
    }


    function tryNextDevice() {
        // If potentialDevices is empty, device will be undefined.
        // That will get us back here next time a device is connected.
        device = potentialDevices.shift();
        if (device) {
            device.open({ stopBits: 0, bitRate: 115200, ctsFlowControl: 0 }, deviceOpened);
        }
    }


    var watchdog = null;
    function deviceOpened(dev) {
        if (!dev) {
            // Opening the port failed.
            tryNextDevice();
            return;
        }
        //alert("deviceOpened");
        //device.set_receive_handler('arduino',processData);
        device.set_receive_handler('GeekeBrain Tero', processData);
    };


    ext._deviceRemoved = function(dev) {
        if(device != dev) return;
        device = null;
        alert("Se ha cerrado la conexión con el GeekeBrain.");
    };


    ext._shutdown = function() {
        if(device) device.close();
        device = null;
        alert("_shutdown");
    };


    ext._getStatus = function() {
        if(!device) {
            return {status: 1, msg: 'Arduino disconnected'};
        }

        if(watchdog) return {status: 1, msg: 'Probing for Arduino'};


        return {status: 2, msg: 'Arduino connected'};
    }

    var descriptor = {};
    ScratchExtensions.register('GeekeBrain Tero', descriptor, ext, {type: 'serial'});
})({});
